<?php
array_push($job_strings, 'updateGCalMeetingEvents');
require_once 'modules/Administration/Administration.php';
function updateGCalMeetingEvents() {
    global $db;
    $admin = new Administration();
    $admin->retrieveSettings();
    $enabledModules = $admin->settings['gcal_from_module'];
    $CLIENT_ID = $admin->settings['gcal_client_id'];
    $CLIENT_SECRET = $admin->settings['gcal_client_secret'];
    $oUser = BeanFactory::getBean("Users", "1");
    $response_status = array("needsAction" => "none", "declined" => "decline", "tentative" => "tentative", "accepted" => "accept");
    $getMeetings = "SELECT * FROM meetings WHERE deleted=0 AND status='Planned' AND assigned_user_id IS NOT NULL AND gcal_event_id IS NOT NULL";
    $resMeetings = $db->query($getMeetings);
    while ($rowMeetings = $db->fetchByAssoc($resMeetings)) {
        $oUser = BeanFactory::getBean("Users", $rowMeetings['assigned_user_id']);
        if (!empty($oUser->gcal_auth) && !empty($oUser->gcal_calendar_id)) {
            header('Content-type: application/json');
            require_once 'GC/google-calendar-api.php';
            try {
                $capi = new GoogleCalendarApi();
                if (time() > $oUser->gcal_auth_expire) {
                    //require_once 'GC/settings.php';
                    // Get a new access token using the refresh token
                    $data = $capi->GetRefreshedAccessToken($CLIENT_ID, $oUser->gcal_auth_refresh, $CLIENT_SECRET);
                    // Again save the expiry time of the new token
                    $oUser->gcal_auth_expire = time() + $data['expires_in'];
                    // The new access token
                    $oUser->gcal_auth = $data['access_token'];
                    $oUser->processed = true;
                    $oUser->save();
                }
                // Get user calendar timezone
                $user_timezone = $capi->GetUserCalendarTimezone($oUser->gcal_auth);
                $update_event = $capi->getCalendarEventUpdate($oUser->gcal_calendar_id, $rowMeetings['gcal_event_id'], $oUser->gcal_auth);
                foreach ($update_event['attendees'] as $attendee) {
                    $getSQL = "SELECT email_addr_bean_rel.bean_id, email_addr_bean_rel.bean_module, email_addresses.email_address FROM email_addr_bean_rel INNER JOIN email_addresses ON email_addresses.id = email_addr_bean_rel.email_address_id AND email_addr_bean_rel.deleted = 0 WHERE email_addresses.deleted = 0 AND email_addresses.email_address='" . $attendee['email'] . "' AND email_addr_bean_rel.primary_address = '1'";
                    $res = $db->query($getSQL);
                    while ($row = $db->fetchByAssoc($res)) {
                        if ($row['bean_module'] == "Users") {
                            $checkUserRel = "SELECT id FROM meetings_users WHERE deleted=0 AND meeting_id='" . $rowMeetings['id'] . "' AND user_id='" . $row['bean_id'] . "' ORDER BY date_modified DESC limit 1";
                            $resUserRel = $db->query($checkUserRel);
                            $rowUserRel = $db->fetchByAssoc($resUserRel);
                            if (!empty($rowUserRel['id'])) {
                                $updateUserRel = "UPDATE meetings_users SET accept_status='" . $response_status[$attendee['responseStatus']] . "' WHERE deleted=0 AND id='" . $rowUserRel['id'] . "'";
                                $updateRes = $db->query($updateUserRel);
                            }
                        }
                        if ($row['bean_module'] == "Contacts") {
                            $checkUserRel = "SELECT id FROM meetings_contacts WHERE deleted=0 AND meeting_id='" . $rowMeetings['id'] . "' AND contact_id='" . $row['bean_id'] . "' ORDER BY date_modified DESC limit 1";
                            $resUserRel = $db->query($checkUserRel);
                            $rowUserRel = $db->fetchByAssoc($resUserRel);
                            if (!empty($rowUserRel['id'])) {
                                $updateUserRel = "UPDATE meetings_contacts SET accept_status='" . $response_status[$attendee['responseStatus']] . "' WHERE deleted=0 AND id='" . $rowUserRel['id'] . "'";
                                $updateRes = $db->query($updateUserRel);
                            }
                        }
                        if ($row['bean_module'] == "Leads") {
                            $checkUserRel = "SELECT id FROM meetings_leads WHERE deleted=0 AND meeting_id='" . $rowMeetings['id'] . "' AND lead_id='" . $row['bean_id'] . "' ORDER BY date_modified DESC limit 1";
                            $resUserRel = $db->query($checkUserRel);
                            $rowUserRel = $db->fetchByAssoc($resUserRel);
                            if (!empty($rowUserRel['id'])) {
                                $updateUserRel = "UPDATE meetings_leads SET accept_status='" . $response_status[$attendee['responseStatus']] . "' WHERE deleted=0 AND id='" . $rowUserRel['id'] . "'";
                                $updateRes = $db->query($updateUserRel);
                            }
                        }
                    }
                }
            }
            catch(Exception $e) {
                $GLOBALS['log']->fatal(json_encode(array('error' => 1, 'message' => $e->getMessage())));
            }
        }
    }
    return true;
}
