<?php

/**
 * @Author: Khwaish Nagdev
 * @Date:   2021-03-30 15:25:11
 * @Last Modified by:   khwaish_nagdev
 * @Last Modified time: 2022-02-23 17:09:08
 */
array_push($job_strings, 'sync_gcal');
require_once 'modules/Administration/Administration.php';
function sync_gcal() {
	global $db, $timedate;
	$admin = new Administration();
	$admin->retrieveSettings();
	$CLIENT_ID = $admin->settings['gcal_client_id'];
	$CLIENT_SECRET = $admin->settings['gcal_client_secret'];
	$eventType = $admin->settings['gcal_event_module'];
	require_once 'GC/google-calendar-api.php';
	require_once 'modules/GCal/license/GCalLicense.php';
	//$validate = GCalLicense::isValid();
	$validate = true;
	$gcal_enable = $admin->settings['gcal_enable'];
	if (!empty($gcal_enable) && $validate === true) {

		$capi = new GoogleCalendarApi();
		$getUsers = "SELECT * FROM users WHERE deleted=0 AND status='Active' AND gcal_auth IS NOT NULL AND gcal_auth_refresh IS NOT NULL";
		$result = $db->query($getUsers);
		while ($row = $db->fetchByAssoc($result)) {

			$oUser = BeanFactory::getBean("Users", $row['id']);

			if (!empty($oUser->gcal_auth) && !empty($oUser->gcal_auth_refresh)) {

				try {
					if (time() > $oUser->gcal_auth_expire) {
						//require_once 'GC/settings.php';

						// Get a new access token using the refresh token
						$data = $capi->GetRefreshedAccessToken($CLIENT_ID, $oUser->gcal_auth_refresh, $CLIENT_SECRET);

						// Again save the expiry time of the new token
						$oUser->gcal_auth_expire = time() + $data['expires_in'];

						// The new access token
						$oUser->gcal_auth = $data['access_token'];
						$oUser->processed = true;
						$oUser->save();
					}

					// Get user calendar timezone
					$user_timezone = $capi->GetUserCalendarTimezone($oUser->gcal_auth);

					//get last updated time
					$time = $admin->settings["gcal_last_updated"];
					if (empty($time)) {
						$time = time('c');
					}
					//Get Calendar Events
					$calendarsItem = $capi->GetCalendarEvents($oUser->gcal_auth, $oUser->gcal_calendar_id, $time);
					$time = date('c');
					$admin->saveSetting("gcal", "last_updated", $time);
					foreach ($calendarsItem as $key => $value) {
						$createNewEvent = checkExistingEvents($value['id']);
						if (strpos($value['start']['dateTime'], '+') !== false) {
							$start_date_arr = explode("+", $value['start']['dateTime']);
							$sign = "-";
						} elseif (strpos($value['start']['dateTime'], '-') !== false) {
							$start_date_arr = explode("-", $value['start']['dateTime']);
							$sign = "+";
						}

						$timeArr = explode(':', $start_date_arr[1]);
						$decTime = ($timeArr[0] * 60) + ($timeArr[1]);

						$start_date = str_replace("T", " ", $start_date_arr[0]);
						$start_date_ts = strtotime($sign . $decTime . 'minutes', strtotime($start_date));

						$db_start_date = date('Y-m-d H:i:s', $start_date_ts);

						if (strpos($value['end']['dateTime'], '+') !== false) {
							$end_date_arr = explode("+", $value['end']['dateTime']);
							$sign = "-";
						} elseif (strpos($value['end']['dateTime'], '-') !== false) {
							$end_date_arr = explode("-", $value['end']['dateTime']);
							$sign = "+";
						}
						$end_date = str_replace("T", " ", $end_date_arr[0]);
						$end_date_ts = strtotime($sign . $decTime . 'minutes', strtotime($end_date));

						$db_end_date = date('Y-m-d H:i:s', $end_date_ts);
						$datetime1 = new DateTime($db_start_date);
						$datetime2 = new DateTime($db_end_date);
						$interval = $datetime1->diff($datetime2);
						$h = 0;
						$m = 0;
						if ($interval->d >= 1) {
							$h = $interval->d * 24;
						}
						$h = $interval->h + $h;
						$m = $interval->i;

						if ($createNewEvent) {

							$now = $timedate->nowDb();
							$id = create_guid();

							if ($eventType == "calls") {
								$query = "INSERT INTO calls(id,gcal_event_id,name,description,date_start,date_end,duration_hours,duration_minutes,assigned_user_id,date_entered,date_modified,created_by,modified_user_id,event_source) VALUE('" . $id . "','" . $value['id'] . "','" . $value['summary'] . "','" . $value['description'] . "','" . $db_start_date . "','" . $db_end_date . "','" . $h . "','" . $m . "','" . $oUser->id . "','" . $now . "','" . $now . "','1','1','gcal')";
								$res = $db->query($query);

								if (!empty($value['creator'])) {
									$name = explode(" ", $value['creator']['displayName']);
									$creatorLink = array('email' => $value['creator']['email'], 'first_name' => $name[0], 'last_name' => $name[1], 'status' => 'accept');
									addAttendeesCall($creatorLink, $id);
								}
								if (!empty($value['attendees'])) {
									foreach ($value['attendees'] as $attendee) {
										$name = explode(" ", $attendee['displayName']);
										$attendeeLink = array('email' => $attendee['email'], 'first_name' => $name[0], 'last_name' => $name[1], 'status' => 'none');
										addAttendeesCall($attendeeLink, $id);
									}
								}

							} elseif ($eventType == "tasks") {
								$query = "INSERT INTO tasks(id,gcal_event_id,name,description,date_start,date_due,assigned_user_id,date_entered,date_modified,created_by,modified_user_id,event_source) VALUE('" . $id . "','" . $value['id'] . "','" . $value['summary'] . "','" . $value['description'] . "','" . $db_start_date . "','" . $db_end_date . "','" . $oUser->id . "','" . $now . "','" . $now . "','1','1','gcal')";
								$res = $db->query($query);
							} else {
								$query = "INSERT INTO meetings(id,gcal_event_id,name,description,date_start,date_end,duration_hours,duration_minutes,assigned_user_id,date_entered,date_modified,created_by,modified_user_id,event_source) VALUE('" . $id . "','" . $value['id'] . "','" . $value['summary'] . "','" . $value['description'] . "','" . $db_start_date . "','" . $db_end_date . "','" . $h . "','" . $m . "','" . $oUser->id . "','" . $now . "','" . $now . "','1','1','gcal')";

								$res = $db->query($query);

								if (!empty($value['creator'])) {
									$name = explode(" ", $value['creator']['displayName']);
									$creatorLink = array('email' => $value['creator']['email'], 'first_name' => $name[0], 'last_name' => $name[1], 'status' => 'accept');

									addAttendeesMeeting($creatorLink, $id);
								}
								if (!empty($value['attendees'])) {
									foreach ($value['attendees'] as $attendee) {
										$name = explode(" ", $attendee['displayName']);
										$attendeeLink = array('email' => $attendee['email'], 'first_name' => $name[0], 'last_name' => $name[1], 'status' => 'none');
										addAttendeesMeeting($attendeeLink, $id);
									}
								}
							}
						}
					}

				} catch (Exception $e) {
					//header('Bad Request', true, 400);
					$GLOBALS['log']->fatal(json_encode(array('error' => 1, 'message' => $e->getMessage())));
				}
			}
		}
		return true;
	}
	return false;
}
function checkExistingEvents($event_id) {
	global $db;
	$modules = array("Tasks" => "tasks", "Calls" => "calls", "Meetings" => "meetings");
	foreach ($modules as $key => $value) {
		$query = "SELECT count(*) AS COUNT FROM " . $value . " WHERE deleted=0 AND gcal_event_id='" . $event_id . "'";

		$result = $db->query($query);
		$row = $db->fetchByAssoc($result);
		if ($row['COUNT'] > 0) {
			return false;
		}
	}
	return true;
}
function addAttendeesCall($emailArr = array(), $call_id) {
	global $db, $timedate;
	$value = $emailArr;
	$now = $timedate->nowDb();
	$id = create_guid();
	$checkExist = checkEmailExist($value);
	if (!empty($checkExist)) {
		//Link Lead calls_leads
		if ($checkExist['bean_module'] == "Leads") {
			$query = "INSERT INTO `calls_leads`(`id`, `call_id`, `lead_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $call_id . "','" . $checkExist['bean_id'] . "','1','accept','" . $now . "','0')";
			$res = $db->query($query);
		}
		//Link Users calls_users
		elseif ($checkExist['bean_module'] == "Users") {
			$query = "INSERT INTO `calls_users`(`id`, `call_id`, `user_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $call_id . "','" . $checkExist['bean_id'] . "','1','accept','" . $now . "','0')";
			$res = $db->query($query);
		}
		//Link Contacts calls_contacts
		else {
			$query = "INSERT INTO `calls_contacts`(`id`, `call_id`, `contact_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $call_id . "','" . $checkExist['bean_id'] . "','1','accept','" . $now . "','0')";
			$res = $db->query($query);
		}
	} else {
		$newContact = createNewContact($value['email'], $value['first_name'], $value['last_name']);
		$query = "INSERT INTO `calls_contacts`(`id`, `call_id`, `contact_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $meeting_id . "','" . $newContact['id'] . "','1','accept','" . $now . "','0')";
		$res = $db->query($query);
	}

}
function addAttendeesMeeting($emailArr = array(), $meeting_id) {
	global $db, $timedate;
	$value = $emailArr;

	$now = $timedate->nowDb();
	$id = create_guid();
	$checkExist = checkEmailExist($value['email']);

	if (!empty($checkExist)) {
		//Link Lead meetings_leads
		if ($checkExist['bean_module'] == "Leads") {
			$query = "INSERT INTO `meetings_leads`(`id`, `meeting_id`, `lead_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $meeting_id . "','" . $checkExist['bean_id'] . "','1','accept','" . $now . "','0')";

			$res = $db->query($query);
		}
		//Link Users meetings_users
		elseif ($checkExist['bean_module'] == "Users") {
			$query = "INSERT INTO `meetings_users`(`id`, `meeting_id`, `user_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $meeting_id . "','" . $checkExist['bean_id'] . "','1','accept','" . $now . "','0')";

			$res = $db->query($query);
		}
		//Link Contacts meetings_contacts
		else {
			$query = "INSERT INTO `meetings_contacts`(`id`, `meeting_id`, `contact_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $meeting_id . "','" . $checkExist['bean_id'] . "','1','accept','" . $now . "','0')";

			$res = $db->query($query);
		}
	} else {
		$newContact = createNewContact($value['email'], $value['first_name'], $value['last_name']);
		$query = "INSERT INTO `meetings_contacts`(`id`, `meeting_id`, `contact_id`, `required`, `accept_status`, `date_modified`, `deleted`) VALUES ('" . $id . "','" . $meeting_id . "','" . $newContact['id'] . "','1','accept','" . $now . "','0')";

		$res = $db->query($query);
	}

}
function checkEmailExist($email_address) {

	global $db;
	$query = 'SELECT bean_id,bean_module FROM email_addr_bean_rel INNER JOIN email_addresses ON email_addresses.id = email_addr_bean_rel.email_address_id AND email_addr_bean_rel.deleted = 0 WHERE email_addresses.deleted = 0 AND email_address = "' . $email_address . '" ORDER BY `email_addr_bean_rel`.`date_created` DESC limit 1';

	$res = $db->query($query);
	$row = $db->fetchByAssoc($res);

	if (!empty($row['bean_id'])) {
		return $row;
	}
	return false;
}
function createNewContact($email_addr, $first_name, $last_name) {
	$oContact = BeanFactory::newBean("Contacts");
	$oContact->first_name = $first_name;
	$oContact->last_name = $last_name;
	if (empty($oContact->last_name)) {
		$oContact->last_name = $email_addr;
	}
	$oContact->email1 = $email_addr;
	$oContact->processed = true;
	$oContact->save();

	return array('id' => $oContact->id);
}