<?php
//ini_set('display_errors', '1');
require_once('custom/include/stripe-php-master/init.php');
require_once('custom/modules/Users/SendEmailCls.php');
global $sugar_config, $app_list_strings, $log ,$current_user, $db;

// Retrieve JSON from POST body 
$jsonStr = file_get_contents('php://input'); 
$jsonObj = json_decode($jsonStr); 

if($_REQUEST['status'] == "paid"){ ?>
    <!DOCTYPE html>
    <html lang="en">
        <head>
            <title>User Registered Successfully</title>
            <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
        </head>
        <body>
            <div class="container">
                <br>
                <div class="row">
                    <div class="col-2"></div>
                    <div class="col-8">
                        <div class="alert alert-success">
                            <strong>Success!</strong> You have been registered successfully. Please check your email for details.
                        </div>
                    </div>
                    <div class="col-2"></div>
                </div>
            </div>
        </body>
    </html>
    
<?php
die;
}
if($jsonObj->request_type == "create_customer_subscription"){
    \Stripe\Stripe::setApiKey($sugar_config['stripSecretKey']);
    // $GLOBALS['log']->fatal("Creating customer subscription", $jsonObj, $sugar_config['stripSecretKey']);


    // $subscr_plan_id = !empty($jsonObj->subscr_plan_id)?$jsonObj->subscr_plan_id:''; 
    $name = !empty($jsonObj->name)?$jsonObj->name:''; 
    $email = !empty($jsonObj->email)?$jsonObj->email:''; 

    $amount = $sugar_config['stripe_subscription'][$jsonObj->plan]['price'];
    $planName = $sugar_config['stripe_subscription'][$jsonObj->plan]['name'];
    $planInterval = $sugar_config['stripe_subscription'][$jsonObj->plan]['interval'];
    $intervalCount = $sugar_config['stripe_subscription'][$jsonObj->plan]['interval_count'];
    $planPriceCents = $amount * 100;


    try {   
        $customer = \Stripe\Customer::create([ 
            'name' => $name,  
            'email' => $email 
        ]); 
        // $GLOBALS['log']->fatal(["Customer Created", $customer]);
    }catch(Exception $e) {   
        $api_error = $e->getMessage();   
    } 
     
    if(empty($api_error) && $customer){ 
        try { 
            // Create price with subscription info and interval 
            $price = \Stripe\Price::create([ 
                'unit_amount' => $planPriceCents, 
                'currency' => 'usd',
                'recurring' => ['interval' => $planInterval, 'interval_count' => $intervalCount], 
                'product_data' => ['name' => $planName], 
            ]);
            // $GLOBALS['log']->fatal(["Price Created", $price]);
        } catch (Exception $e) {  
            $api_error = $e->getMessage(); 
        } 
         
        if(empty($api_error) && $price){ 
            // Create a new subscription 
            try { 
                $subscription = \Stripe\Subscription::create([ 
                    'customer' => $customer->id, 
                    'items' => [[ 
                        'price' => $price->id, 
                    ]], 
                    'payment_behavior' => 'default_incomplete', 
                    'payment_settings' => ['save_default_payment_method' => 'on_subscription'], 
                    'expand' => ['latest_invoice.payment_intent'], 
                ]); 
                // $GLOBALS['log']->fatal(["Subscription Created", $subscription]);
            }catch(Exception $e) { 
                $api_error = $e->getMessage(); 
            } 
             
            if(empty($api_error) && $subscription){ 
                $output = [ 
                    'subscriptionId' => $subscription->id, 
                    'clientSecret' => $subscription->latest_invoice->payment_intent->client_secret, 
                    'customerId' => $customer->id 
                ]; 
                //$GLOBALS['log']->fatal(["output", $output]);
                echo json_encode($output); 
            }else{ 
                echo json_encode(['error' => $api_error]); 
            } 
        }else{ 
            echo json_encode(['error' => $api_error]); 
        } 
    }else{ 
        echo json_encode(['error' => $api_error]); 
    } 

}else if($jsonObj->request_type == 'update_payment'){ 
    \Stripe\Stripe::setApiKey($sugar_config['stripSecretKey']);
    $payment_intent = !empty($jsonObj->payment_intent) ? $jsonObj->payment_intent : ''; 
    $description = !empty($jsonObj->description) ? $jsonObj->description : ''; 
    //$GLOBALS['log']->fatal(["Payment Intent", $payment_intent]);

    $paymentIntent = \Stripe\PaymentIntent::update($payment_intent->id, ['description' => $description]);
        
    if(!empty($paymentIntent) && $paymentIntent->status == 'succeeded'){ 

        // $current_date = date('Y-m-d H:i:s');
        // $sendEmail = new SendEmailCls();
        // $user_name = $jsonObj->first_name.".".$jsonObj->last_name;
        // $userBean = BeanFactory::newBean("Users");
        // $userBean->first_name = ucfirst($jsonObj->first_name);
        // $userBean->last_name = ucfirst($jsonObj->last_name);
        // $userBean->user_name = $user_name;
        // $userBean->email1 = $jsonObj->customer_email;
        // $userBean->employee_status = "Active";
        // $userBean->status = "Active";
        // $password = $sendEmail->generateRandomPassword(8);
        // $userBean->user_hash = md5($password);
        // $userBean->purchase_date = $current_date;
        // $userBean->save();
        
        // $guid = create_guid();
        // $agentRoleID = $sugar_config['agentRoleID'];

        // $sql = "INSERT INTO `acl_roles_users`(`id`, `role_id`, `user_id`, `date_modified`) 
        //     VALUES ('$guid','$agentRoleID', '$userBean->id','$current_date')";
        // $db->query($sql);
        
        
        // $sendEmail->sendUserRegEmail($userBean->id, $password);
        
        $output = [ 
            'status' => $paymentIntent->status, 
            'payment_id' => $paymentIntent->id
        ]; 
        echo json_encode($output);
    }else{ 
        echo json_encode(['error' => 'Transaction has been failed!']); 
    } 

}else{
?>
<!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Stripe Payment</title>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
        <script src="https://js.stripe.com/v3/"></script>
        <style>
            #submitBtn{
                color:white; 
                background-color:#bab945; 
            }

            #submitBtn:focus {
                background-color:#a1a033;
                border:none;
            }
            .form-control:focus{
                border-color: #000000;
                box-shadow: 0 0 0 0.1rem #000;
            }
        </style>
    </head>
    <body>
        <div class="container">
            <br>
            <h5 style="text-align:center;">Pay your amount using stripe</h5>
            <div class="panel">
                <div class="panel-body">
                    <br>
                    <form id="subscrFrm">
                        <div class="row">
                            <div class="col-2"></div>
                            <div class="col-4">
                                <div class="form-group">
                                    <label for="first_name">First Name <span style="color:red;">*</span></label>
                                    <input type="text" class="form-control form-control-sm" id="first_name" name="first_name" value="" required onchange="setup_name('first_name')">
                                </div>
                                <div class="form-group">
                                    <label for="email">Email <span style="color:red;">*</span></label>
                                    <input type="email" class="form-control form-control-sm" id="email" name="email" value="" required>
                                    <input type="hidden" id="stripe_customer_id" value="">
                                    <input type="hidden" id="account_id" value="">
                                    <input type="hidden" id="crm_payment_id" value="">
                                </div>
                                <div class="form-group">
                                    <label for="description">Description</label>
                                    <textarea rows="3" class="form-control form-control-sm" id="description" name="description" ></textarea>
                                </div>
                                
                            </div>
                            <div class="col-4">
                                <div class="form-group">
                                    <label for="last_name">Last Name <span style="color:red;">*</span></label>
                                    <input type="text" class="form-control form-control-sm" id="last_name" name="last_name" value="" required onchange="setup_name('last_name')">
                                </div>
                                <div class="form-group">
                                    <!-- <label for="amount">Amount ($)</label> -->
                                    <!-- <input type="text" class="form-control form-control-sm" id="amount" name="amount" value="" required onchange="setup_name('amount')"> -->
                                    <label for="plan">Plan</label>
                                    <select class="form-control form-control-sm" name="plan" id="plan" required>
                                        <option value=""></option>
                                        <option value="monthly"><?php echo $sugar_config['stripe_subscription']['monthly']['name']."[".$sugar_config['stripe_subscription']['monthly']['price']."$]"; ?></option>
                                    </select>
                                </div>
                                <div class="form-group">
                                    <label>Card Info</label>
                                    <div id="card-element">
                                    </div>
                                </div>
                                <div id="paymentResponse" class="hidden" style="color:red;"></div>
                                <br>
                                
                                <button id="submitBtn" class="btn btn-sm float-right" >
                                    <span id="buttonText">Proceed</span>
                                    <img style="height:20px; display:none;" id="btn_loader" src="./upload/load.gif" alt="loader">
                                </button>
                            </div>
                            <div class="col-2"></div>
                        </div>
                    </form>
                    
                </div>
                
            </div>
        </div>
    </body>
    </html>

<script>
    // Create an instance of the Stripe object and set your publishable API key
    const stripe = Stripe('<?php echo $sugar_config['stripePublicKey']; ?>');

    // Select subscription form element
    const subscrFrm = document.querySelector("#subscrFrm");

    // Attach an event handler to subscription form
    subscrFrm.addEventListener("submit", handleSubmit);

    /*initialize();*/
    let elements = stripe.elements();
    var style = {
        base: {
            lineHeight: "30px",
            fontSize: "16px",
            border: "1px solid #ced4da",
        }
    };
    let cardElement = elements.create('card', { style: style });
    cardElement.mount('#card-element');
    cardElement.on('change', function (event) {
        displayError(event);
    });

    function displayError(event) {
        if (event.error) {
            showMessage(event.error.message);
        }
    }

    async function handleSubmit(e) {
        e.preventDefault();
        setLoading(true);
        let first_name = document.getElementById("first_name").value;
        let last_name = document.getElementById("last_name").value;
        let customer_name = first_name+" "+last_name;
        let customer_email = document.getElementById("email").value;
        let plan = document.getElementById("plan").value;
        let description = document.getElementById("description").value;
        
        // Post the subscription info to the server-side script
        fetch("index.php?entryPoint=stripePaymentEP", {
            method: "POST",
            headers: { "Content-Type": "application/json" },
            body: JSON.stringify({ request_type:'create_customer_subscription', name: customer_name, email: customer_email, plan: plan, description: description}),
        })
        .then(response => response.json())
        .then(data => {
            if (data.subscriptionId && data.clientSecret) {
                paymentProcess(data.subscriptionId, data.clientSecret, data.customerId);
            } else {
                showMessage(data.error);
            }
            // setLoading(false);
        })
        .catch(console.error);
    }

    async function paymentProcess(subscriptionId, clientSecret, customerId) {
        let first_name = document.getElementById("first_name").value;
        let last_name = document.getElementById("last_name").value;
        let customer_name = first_name+" "+last_name;
        let customer_email = document.getElementById("email").value;
        let description = document.getElementById("description").value;

        // Create payment method and confirm payment intent.
        stripe.confirmCardPayment(clientSecret, {
            payment_method: {
                card: cardElement,
                billing_details: {
                    name: customer_name,
                },
            }
        }).then((result) => {
            if (result.error) {
                showMessage(result.error.message);
                setLoading(false);
            } else {
                // Successful subscription payment
                // Post the transaction info to the server-side script and redirect to the payment status page
                fetch("index.php?entryPoint=stripePaymentEP", {
                    method: "POST",
                    headers: { "Content-Type": "application/json" },
                    body: JSON.stringify({ request_type: 'update_payment', subscription_id: subscriptionId, customer_id: customerId, payment_intent: result.paymentIntent, description: description, first_name: first_name, last_name: last_name, customer_email: customer_email }),
                })
                .then(response => response.json())
                .then(data => {
                    if (data.payment_id) {
                        console.log(["Payment done now redirection"]);
                        window.location.href = window.location.href+"&status=paid";
                    } else {
                        showMessage(data.error);
                        setLoading(false);
                    }
                })
                .catch(console.error);
            }
        });
    }

    // Display message
    function showMessage(messageText) {
        const messageContainer = document.querySelector("#paymentResponse");
        messageContainer.classList.remove("hidden");
        messageContainer.textContent = messageText;
        setTimeout(function () {
            messageContainer.classList.add("hidden");
            messageContainer.textContent = "";
        }, 5000);
    }

    // Show a spinner on payment submission
    function setLoading(isLoading) {
        if (isLoading) {
            // Disable the button and show a spinner
            document.querySelector("#submitBtn").disabled = true;
            document.querySelector("#btn_loader").style.display = "inline";
            document.querySelector("#buttonText").classList.add("hidden");
        } else {
            // Enable the button and hide spinner
            document.querySelector("#submitBtn").disabled = false;
            document.querySelector("#btn_loader").style.display = "none";
            document.querySelector("#buttonText").classList.remove("hidden");
        }
    }

    function setup_name(id){
        var temp_value;
        if(document.getElementById(id).value == ""){
            alert("This field is required.");
            return false;
        }
        if(id == "amount"){
            temp_value = document.getElementById(id).value.replace(/[^0-9]/g, '');
        }else{
            temp_value = document.getElementById(id).value.replace(/[^a-zA-Z]/g, '').toLowerCase();
        }
        document.getElementById(id).value = temp_value;
    }
</script>

<?php 
}
?>