<?php
require_once('custom/include/stripe-php-master/init.php');
require_once('custom/modules/Users/SendEmailCls.php');
global $sugar_config, $db;

\Stripe\Stripe::setApiKey($sugar_config['stripSecretKey']);


// This is your Stripe CLI webhook secret for testing your endpoint locally.
$endpoint_secret = $sugar_config['webhook_sec'];

$payload = @file_get_contents('php://input');
$sig_header = $_SERVER['HTTP_STRIPE_SIGNATURE'];
$event = null;

try {
    
    $event = \Stripe\Webhook::constructEvent(
    $payload, $sig_header, $endpoint_secret
  );
} catch(\UnexpectedValueException $e) {
    
  // Invalid payload
  http_response_code(400);
  exit();
} catch(\Stripe\Exception\SignatureVerificationException $e) {
    
  // Invalid signature
  http_response_code(400);
  exit();
}
$GLOBALS['log']->fatal(["Web hook called", $event]);
if($event->type == "customer.subscription.deleted"){
    
    $customer_id = $event->data->object->customer;
    
    $customer = \Stripe\Customer::retrieve($customer_id, []);
    $customer_email = $customer->email;
    $sql = 'SELECT eabr.bean_id as user_id FROM email_addr_bean_rel eabr left join email_addresses eas on eas.id = eabr.email_address_id where eas.email_address like "'.$customer_email.'" and eas.deleted = 0 order by eabr.date_created desc limit 1 ';
    $user_data = $db->query($sql, false);
    
    while (($user_id = $db->fetchByAssoc($user_data)) != null){
        $userID = $user_id['user_id'];
        
        $date = new DateTime(date('Y-m-d'));
        $date->add(new DateInterval('P30D'));
        $end_date = $date->format('Y-m-d H:i:s');
        
        $GLOBALS['log']->fatal(["Inner Loop",$userID, $end_date]);
        
        $userBean = BeanFactory::getBean('Users', $userID);
        $userBean->end_date = $end_date;
        $userBean->processed = true;
        $userBean->save();
    }
    
}elseif($event->type == "customer.subscription.created"){
    $GLOBALS['log']->fatal(["customer.subscription.created", $event->data->object->customer]);
    
    $cus_id = $event->data->object->customer;
    $customer = \Stripe\Customer::retrieve($cus_id, []);

    $full_name = explode(" ", $customer->name);
    $user_name = strtolower(implode(".", $full_name));
    $first_name = $full_name[0];
    unset($full_name[0]);
    $last_name = implode(" ", $full_name);
    
    $current_date = date('Y-m-d H:i:s');
    $sendEmail = new SendEmailCls();
    $userBean = BeanFactory::newBean("Users");
    $userBean->first_name = ucfirst($first_name);
    $userBean->last_name = ucfirst($last_name);
    $userBean->user_name = $user_name;
    $userBean->email1 = $customer->email;
    $userBean->employee_status = "Active";
    $userBean->status = "Active";
    $password = $sendEmail->generateRandomPassword(8);
    $userBean->user_hash = md5($password);
    $userBean->purchase_date = $current_date;
    $userBean->save();
    
    $guid = create_guid();
    $agentRoleID = $sugar_config['agentRoleID'];

    $sql = "INSERT INTO `acl_roles_users`(`id`, `role_id`, `user_id`, `date_modified`) 
        VALUES ('$guid','$agentRoleID', '$userBean->id','$current_date')";
    $db->query($sql);
    
    $sendEmail->sendUserRegEmail($userBean->id, $password);
}else{
    echo 'Received unknown event type ' . $event->type;
}




http_response_code(200);