<?php

/**
 * @Author: Khwaish Nagdev
 * @Date:   2021-03-15 19:01:39
 * @Last Modified by:   Khwaish Nagdev
 * @Last Modified time: 2021-03-15 19:17:04
 */
if (!defined('sugarEntry') || !sugarEntry) {
	die('Not A Valid Entry Point');
}

require_once 'include/MVC/View/SugarView.php';

class ViewTest extends SugarView {
	public function __construct() {
		parent::SugarView();
	}

	public function preDisplay() {
		$this->dv->tpl = 'modules/GCal/tpl/configureGCal.tpl';
	}

	public function display() {

		global $sugar_config, $mod_strings, $app_strings;
		require_once 'modules/Administration/Administration.php';
		$smarty = new Sugar_Smarty();
		$smarty->assign('MOD', $mod_strings);
		$smarty->assign('APP', $app_strings);

		$admin = new Administration();
		$admin->retrieveSettings();

		if (!empty($admin->settings['gcal_enable'])) {
			$smarty->assign('GCAL_ENABLED', 'checked');
		} else {
			$smarty->assign('GCAL_ENABLED', '');
		}
		$smarty->assign('QUOTES_CHECKED', '');
		$smarty->assign('INVOICE_CHECKED', '');
		$smarty->assign('CONTRACT_CHECKED', '');
		$smarty->assign('QUOTES_CUSTOM_CHECKED', '');
		$smarty->assign('INVOICE_CUSTOM_CHECKED', '');
		$smarty->assign('CONTRACT_CUSTOM_CHECKED', '');

		$smarty->assign('CUSTOMER', '');
		$smarty->assign('CLIENT', '');

		if (array_key_exists('gcal_modules', $admin->settings)) {
			$enabledModules = $admin->settings['gcal_modules'];
			$modules = explode(",", $enabledModules);

			foreach ($modules as $key => $value) {
				switch ($value) {
				case 'AOS_Quotes':
					$smarty->assign('QUOTES_CHECKED', 'checked');
					break;
				case 'AOS_Invoices':
					$smarty->assign('INVOICE_CHECKED', 'checked');
					break;
				case 'AOS_Contracts':
					$smarty->assign('CONTRACT_CHECKED', 'checked');
					break;
				default:
					# code...
					break;
				}
			}

			$enabledCustomModules = $admin->settings['gcal_customer_modules'];
			$modules = explode(",", $enabledCustomModules);

			foreach ($modules as $key => $value) {
				switch ($value) {
				case 'AOS_Quotes':
					$smarty->assign('QUOTES_CUSTOM_CHECKED', 'checked');
					break;
				case 'AOS_Invoices':
					$smarty->assign('INVOICE_CUSTOM_CHECKED', 'checked');
					break;
				case 'AOS_Contracts':
					$smarty->assign('CONTRACT_CUSTOM_CHECKED', 'checked');
					break;
				default:
					# code...
					break;
				}
			}
		}
		if (array_key_exists('gcal_features', $admin->settings)) {
			$enabledFeatures = $admin->settings['gcal_features'];
			$features = explode(",", $enabledFeatures);

			foreach ($features as $key => $value) {
				switch ($value) {
				case 'Customer':
					$smarty->assign('CUSTOMER', 'checked');
					break;
				case 'Client':
					$smarty->assign('CLIENT', 'checked');
					break;
				default:
					# code...
					break;
				}
			}
		}
		$smarty->display($this->dv->tpl);
		echo $this->dv->tpl;
	}
}