<?php
/**
 *
 * SugarCRM Community Edition is a customer relationship management program developed by
 * SugarCRM, Inc. Copyright (C) 2004-2013 SugarCRM Inc.
 *
 * SuiteCRM is an extension to SugarCRM Community Edition developed by SalesAgility Ltd.
 * Copyright (C) 2011 - 2018 SalesAgility Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 *
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo and "Supercharged by SuiteCRM" logo. If the display of the logos is not
 * reasonably feasible for technical reasons, the Appropriate Legal Notices must
 * display the words "Powered by SugarCRM" and "Supercharged by SuiteCRM".
 */

$module_name = 'ht_client_products';
$viewdefs[$module_name]['EditView'] = array(
    'templateMeta' => array(
        'includes' => 
        array (
            0 => 
            array (
                'file' => 'modules/ht_client_products/js/edit.js',
            ),
        ),
        'maxColumns' => '2',
        'widths' => array(
            array('label' => '10', 'field' => '30'),
            array('label' => '10', 'field' => '30')
        ),
    ),

    'panels' => array(
        'default' => array (
        0 => 
        array (
          0 => 
          array (
            'name' => 'product_type',
            'label' => 'LBL_PRODUCT_TYPE',
            'studio' => 'visible',
          ),
          1 => 
          array (
            'name' => 'product_provider',
            'comment' => 'The provider of the product',
            'label' => 'LBL_PRODUCT_PROVIDER',
          ),
        ),
        1 => 
        array (
          0 => 
          array (
            'name' => 'product_name',
            'comment' => 'The name of the product',
            'label' => 'LBL_PRODUCT_NAME',
          ),
          1 => '',
        ),
        2 => 
        array (
          0 => 
          array (
            'name' => 'coverage_amount',
            'comment' => 'The coverage amount',
            'label' => 'LBL_COVERAGE_AMOUNT',
          ),
          1 => 
          array (
            'name' => 'coverage_duration',
            'comment' => 'The coverage duration in years',
            'label' => 'LBL_COVERAGE_DURATION',
          ),
        ),
        3 => 
        array (
          0 => 
          array (
            'name' => 'premium_amount',
            'comment' => 'The premium amount',
            'label' => 'LBL_PREMIUM_AMOUNT',
          ),
          1 => 
          array (
            'name' => 'premium_frequency',
            'comment' => 'The premium payment frequency',
            'label' => 'LBL_PREMIUM_FREQUENCY',
          ),
        ),
        4 => 
        array (
          0 => 
          array (
            'name' => 'funding_amount_fia',
            'comment' => 'The funding amount for FIA',
            'label' => 'LBL_FUNDING_AMOUNT_FIA',
          ),
          1 => 
          array (
            'name' => 'product_duration_fia',
            'comment' => 'The product duration for FIA in years',
            'label' => 'LBL_PRODUCT_DURATION_FIA',
          ),
        ),
        5 => 
        array (
          0 => 
          array (
            'name' => 'submit_date',
            'comment' => 'The date of submission',
            'label' => 'LBL_SUBMIT_DATE',
          ),
          1 => 
          array (
            'name' => 'approval_date',
            'comment' => 'The date of approval',
            'label' => 'LBL_APPROVAL_DATE',
          ),
        ),
        6 => 
        array (
          0 => 
          array (
            'name' => 'funded',
            'comment' => 'Funded',
            'label' => 'LBL_FUNDED',
          ),
          1 => 
          array (
            'name' => 'in_force',
            'comment' => 'In Force',
            'label' => 'LBL_IN_FORCE',
          ),
        ),
        7 => 
        array (
          0 => 
          array (
            'name' => 'split_agent',
            'comment' => 'The Split Agent',
            'label' => 'LBL_SPLIT_AGENT',
          ),
          1 => 
          array (
            'name' => 'contact_name',
            'label' => 'LBL_CONTACT_NAME',
          ),
        ),
        8 => 
        array (
          0 => 
          array (
            'name' => 'split_agent_name',
            'comment' => 'Split Agent Name',
            'label' => 'LBL_SPLIT_AGENT_NAME',
            
          ),
          1 => 
          array(
            'name' => 'split_agent_social',
            'comment' => 'Split Agent Social',
            'label' => 'LBL_SPLIT_AGENT_SOCIAL',
          ),
        ),
      ),

    ),

);
