<?php 
 $GLOBALS["dictionary"]["ht_client_products"]=array (
  'table' => 'ht_client_products',
  'audited' => true,
  'inline_edit' => true,
  'duplicate_merge' => true,
  'fields' => 
  array (
    'id' => 
    array (
      'name' => 'id',
      'vname' => 'LBL_ID',
      'type' => 'id',
      'required' => true,
      'reportable' => true,
      'comment' => 'Unique identifier',
      'inline_edit' => false,
    ),
    'name' => 
    array (
      'name' => 'name',
      'vname' => 'LBL_NAME',
      'type' => 'name',
      'link' => true,
      'dbType' => 'varchar',
      'len' => 255,
      'unified_search' => true,
      'full_text_search' => 
      array (
        'boost' => 3,
      ),
      'required' => false,
      'importable' => 'required',
      'duplicate_merge' => 'enabled',
      'merge_filter' => 'selected',
    ),
    'date_entered' => 
    array (
      'name' => 'date_entered',
      'vname' => 'LBL_DATE_ENTERED',
      'type' => 'datetime',
      'group' => 'created_by_name',
      'comment' => 'Date record created',
      'enable_range_search' => true,
      'options' => 'date_range_search_dom',
      'inline_edit' => false,
    ),
    'date_modified' => 
    array (
      'name' => 'date_modified',
      'vname' => 'LBL_DATE_MODIFIED',
      'type' => 'datetime',
      'group' => 'modified_by_name',
      'comment' => 'Date record last modified',
      'enable_range_search' => true,
      'options' => 'date_range_search_dom',
      'inline_edit' => false,
    ),
    'modified_user_id' => 
    array (
      'name' => 'modified_user_id',
      'rname' => 'user_name',
      'id_name' => 'modified_user_id',
      'vname' => 'LBL_MODIFIED',
      'type' => 'assigned_user_name',
      'table' => 'users',
      'isnull' => 'false',
      'group' => 'modified_by_name',
      'dbType' => 'id',
      'reportable' => true,
      'comment' => 'User who last modified record',
      'massupdate' => false,
      'inline_edit' => false,
    ),
    'modified_by_name' => 
    array (
      'name' => 'modified_by_name',
      'vname' => 'LBL_MODIFIED_NAME',
      'type' => 'relate',
      'reportable' => false,
      'source' => 'non-db',
      'rname' => 'user_name',
      'table' => 'users',
      'id_name' => 'modified_user_id',
      'module' => 'Users',
      'link' => 'modified_user_link',
      'duplicate_merge' => 'disabled',
      'massupdate' => false,
      'inline_edit' => false,
    ),
    'created_by' => 
    array (
      'name' => 'created_by',
      'rname' => 'user_name',
      'id_name' => 'modified_user_id',
      'vname' => 'LBL_CREATED',
      'type' => 'assigned_user_name',
      'table' => 'users',
      'isnull' => 'false',
      'dbType' => 'id',
      'group' => 'created_by_name',
      'comment' => 'User who created record',
      'massupdate' => false,
      'inline_edit' => false,
    ),
    'created_by_name' => 
    array (
      'name' => 'created_by_name',
      'vname' => 'LBL_CREATED',
      'type' => 'relate',
      'reportable' => false,
      'link' => 'created_by_link',
      'rname' => 'user_name',
      'source' => 'non-db',
      'table' => 'users',
      'id_name' => 'created_by',
      'module' => 'Users',
      'duplicate_merge' => 'disabled',
      'importable' => 'false',
      'massupdate' => false,
      'inline_edit' => false,
    ),
    'description' => 
    array (
      'name' => 'description',
      'vname' => 'LBL_DESCRIPTION',
      'type' => 'text',
      'comment' => 'Full text of the note',
      'rows' => 6,
      'cols' => 80,
    ),
    'deleted' => 
    array (
      'name' => 'deleted',
      'vname' => 'LBL_DELETED',
      'type' => 'bool',
      'default' => '0',
      'reportable' => false,
      'comment' => 'Record deletion indicator',
    ),
    'created_by_link' => 
    array (
      'name' => 'created_by_link',
      'type' => 'link',
      'relationship' => 'ht_client_products_created_by',
      'vname' => 'LBL_CREATED_USER',
      'link_type' => 'one',
      'module' => 'Users',
      'bean_name' => 'User',
      'source' => 'non-db',
    ),
    'modified_user_link' => 
    array (
      'name' => 'modified_user_link',
      'type' => 'link',
      'relationship' => 'ht_client_products_modified_user',
      'vname' => 'LBL_MODIFIED_USER',
      'link_type' => 'one',
      'module' => 'Users',
      'bean_name' => 'User',
      'source' => 'non-db',
    ),
    'assigned_user_id' => 
    array (
      'name' => 'assigned_user_id',
      'rname' => 'user_name',
      'id_name' => 'assigned_user_id',
      'vname' => 'LBL_ASSIGNED_TO_ID',
      'group' => 'assigned_user_name',
      'type' => 'relate',
      'table' => 'users',
      'module' => 'Users',
      'reportable' => true,
      'isnull' => 'false',
      'dbType' => 'id',
      'audited' => true,
      'comment' => 'User ID assigned to record',
      'duplicate_merge' => 'disabled',
    ),
    'assigned_user_name' => 
    array (
      'name' => 'assigned_user_name',
      'link' => 'assigned_user_link',
      'vname' => 'LBL_ASSIGNED_TO_NAME',
      'rname' => 'user_name',
      'type' => 'relate',
      'reportable' => false,
      'source' => 'non-db',
      'table' => 'users',
      'id_name' => 'assigned_user_id',
      'module' => 'Users',
      'duplicate_merge' => 'disabled',
    ),
    'assigned_user_link' => 
    array (
      'name' => 'assigned_user_link',
      'type' => 'link',
      'relationship' => 'ht_client_products_assigned_user',
      'vname' => 'LBL_ASSIGNED_TO_USER',
      'link_type' => 'one',
      'module' => 'Users',
      'bean_name' => 'User',
      'source' => 'non-db',
      'duplicate_merge' => 'enabled',
      'rname' => 'user_name',
      'id_name' => 'assigned_user_id',
      'table' => 'users',
    ),
    'SecurityGroups' => 
    array (
      'name' => 'SecurityGroups',
      'type' => 'link',
      'relationship' => 'securitygroups_ht_client_products',
      'module' => 'SecurityGroups',
      'bean_name' => 'SecurityGroup',
      'source' => 'non-db',
      'vname' => 'LBL_SECURITYGROUPS',
    ),
    'product_type' => 
    array (
      'name' => 'product_type',
      'type' => 'enum',
      'options' => 'product_type_dom',
      'label' => 'LBL_PRODUCT_TYPE',
      'default' => '',
      'required' => false,
      'len' => 100,
      'audited' => true,
      'massupdate' => false,
      'duplicate_merge' => 'enabled',
      'reportable' => true,
      'importable' => 'true',
      'studio' => 'visible',
      'dependency' => false,
      'inline_edit' => false,
    ),
    'product_provider' => 
    array (
      'name' => 'product_provider',
      'vname' => 'LBL_PRODUCT_PROVIDER',
      'type' => 'varchar',
      'len' => '255',
      'comment' => 'The provider of the product',
      'inline_edit' => false,
    ),
    'product_name' => 
    array (
      'name' => 'product_name',
      'vname' => 'LBL_PRODUCT_NAME',
      'type' => 'varchar',
      'len' => '255',
      'comment' => 'The name of the product',
      'inline_edit' => false,
    ),
    'coverage_amount' => 
    array (
      'name' => 'coverage_amount',
      'vname' => 'LBL_COVERAGE_AMOUNT',
      'type' => 'currency',
      'comment' => 'The coverage amount',
      'inline_edit' => false,
    ),
    'coverage_duration' => 
    array (
      'name' => 'coverage_duration',
      'vname' => 'LBL_COVERAGE_DURATION',
      'type' => 'int',
      'comment' => 'The coverage duration in years',
    ),
    'premium_amount' => 
    array (
      'name' => 'premium_amount',
      'vname' => 'LBL_PREMIUM_AMOUNT',
      'type' => 'currency',
      'comment' => 'The premium amount',
      'inline_edit' => false,
    ),
    'premium_frequency' => 
    array (
      'name' => 'premium_frequency',
      'vname' => 'LBL_PREMIUM_FREQUENCY',
      'type' => 'varchar',
      'len' => '255',
      'comment' => 'The premium payment frequency',
      'inline_edit' => false,
    ),
    'funding_amount_fia' => 
    array (
      'name' => 'funding_amount_fia',
      'vname' => 'LBL_FUNDING_AMOUNT_FIA',
      'type' => 'currency',
      'comment' => 'The funding amount for FIA',
      'inline_edit' => false,
    ),
    'product_duration_fia' => 
    array (
      'name' => 'product_duration_fia',
      'vname' => 'LBL_PRODUCT_DURATION_FIA',
      'type' => 'int',
      'comment' => 'The product duration for FIA in years',
      'inline_edit' => false,
    ),
    'submit_date' => 
    array (
      'name' => 'submit_date',
      'vname' => 'LBL_SUBMIT_DATE',
      'type' => 'date',
      'comment' => 'The date of submission',
    ),
    'approval_date' => 
    array (
      'name' => 'approval_date',
      'vname' => 'LBL_APPROVAL_DATE',
      'type' => 'date',
      'comment' => 'The date of approval',
      'inline_edit' => false,
    ),
    'funded' => 
    array (
      'name' => 'funded',
      'vname' => 'LBL_FUNDED',
      'type' => 'enum',
      'options' => 'checkbox_dom',
      'comment' => 'Funded',
      'inline_edit' => false,
    ),
    'in_force' => 
    array (
      'name' => 'in_force',
      'vname' => 'LBL_IN_FORCE',
      'type' => 'enum',
      'options' => 'checkbox_dom',
      'comment' => 'In Force',
      'inline_edit' => false,
    ),
    'split_agent' => 
    array (
      'name' => 'split_agent',
      'vname' => 'LBL_SPLIT_AGENT',
      'type' => 'enum',
      'options' => 'checkbox_dom',
      'comment' => 'The Split Agent',
      'inline_edit' => false,
    ),
    'split_agent_name' => 
    array (
      'name' => 'split_agent_name',
      'vname' => 'LBL_SPLIT_AGENT_NAME',
      'type' => 'varchar',
      'len' => '255',
      'comment' => 'Split Agent Name',
      'inline_edit' => false,
    ),
    'split_agent_social' => 
    array (
      'name' => 'split_agent_social',
      'vname' => 'LBL_SPLIT_AGENT_SOCIAL',
      'type' => 'varchar',
      'len' => '255',
      'comment' => 'Split Agent Social',
      'inline_edit' => false,
    ),
    'contact_name' => 
    array (
      'name' => 'contact_name',
      'rname' => 'name',
      'id_name' => 'contact_id',
      'vname' => 'LBL_CONTACT_NAME',
      'type' => 'relate',
      'relationship' => 'contact_ht_client_products',
      'link' => 'contact_ht_client_products',
      'table' => 'contacts',
      'join_name' => 'contacts',
      'isnull' => 'true',
      'module' => 'Contacts',
      'bean_name' => 'Contacts',
      'source' => 'non-db',
      'unified_search' => true,
      'inline_edit' => false,
    ),
    'contact_id' => 
    array (
      'name' => 'contact_id',
      'type' => 'id',
      'module' => 'ht_client_products',
      'vname' => 'LBL_CONTACT_ID',
      'audited' => true,
      'massupdate' => false,
      'inline_edit' => false,
    ),
  ),
  'relationships' => 
  array (
    'ht_client_products_modified_user' => 
    array (
      'lhs_module' => 'Users',
      'lhs_table' => 'users',
      'lhs_key' => 'id',
      'rhs_module' => 'ht_client_products',
      'rhs_table' => 'ht_client_products',
      'rhs_key' => 'modified_user_id',
      'relationship_type' => 'one-to-many',
    ),
    'ht_client_products_created_by' => 
    array (
      'lhs_module' => 'Users',
      'lhs_table' => 'users',
      'lhs_key' => 'id',
      'rhs_module' => 'ht_client_products',
      'rhs_table' => 'ht_client_products',
      'rhs_key' => 'created_by',
      'relationship_type' => 'one-to-many',
    ),
    'ht_client_products_assigned_user' => 
    array (
      'lhs_module' => 'Users',
      'lhs_table' => 'users',
      'lhs_key' => 'id',
      'rhs_module' => 'ht_client_products',
      'rhs_table' => 'ht_client_products',
      'rhs_key' => 'assigned_user_id',
      'relationship_type' => 'one-to-many',
    ),
    'securitygroups_ht_client_products' => 
    array (
      'lhs_module' => 'SecurityGroups',
      'lhs_table' => 'securitygroups',
      'lhs_key' => 'id',
      'rhs_module' => 'ht_client_products',
      'rhs_table' => 'ht_client_products',
      'rhs_key' => 'id',
      'relationship_type' => 'many-to-many',
      'join_table' => 'securitygroups_records',
      'join_key_lhs' => 'securitygroup_id',
      'join_key_rhs' => 'record_id',
      'relationship_role_column' => 'module',
      'relationship_role_column_value' => 'ht_client_products',
    ),
  ),
  'optimistic_locking' => true,
  'unified_search' => true,
  'indices' => 
  array (
    'id' => 
    array (
      'name' => 'ht_client_productspk',
      'type' => 'primary',
      'fields' => 
      array (
        0 => 'id',
      ),
    ),
  ),
  'templates' => 
  array (
    'security_groups' => 'security_groups',
    'assignable' => 'assignable',
    'basic' => 'basic',
  ),
  'custom_fields' => false,
);