<?php
if (!defined('sugarEntry') || !sugarEntry) {
	die('Not A Valid Entry Point');
}

global $current_user, $sugar_config;
if (!is_admin($current_user)) {
	sugar_die("Unauthorized access to administration.");
}

require_once 'include/MVC/View/SugarView.php';

class Viewconfigure_gcal extends SugarView {

	public function __construct() {
		parent::__construct();
	}

	public function preDisplay() {
		//$this->dv->tpl = 'modules/GCal/tpl/configureGCal.tpl';
	}

	public function display() {
		global $sugar_config, $mod_strings, $app_strings;
		require_once 'modules/Administration/Administration.php';
		$smarty = new Sugar_Smarty();
		$smarty->assign('MOD', $mod_strings);
		$smarty->assign('APP', $app_strings);

		$admin = new Administration();
		$admin->retrieveSettings();

		$smarty->assign('GCAL_ENABLE', '');
		$smarty->assign('GCAL_CLIENT_ID', '');
		$smarty->assign('GCAL_CLIENT_SECRET', '');
		$smarty->assign('GCAL_NAME', '');
		$smarty->assign('GCAL_TO_MODULE', '');
		$smarty->assign('GCAL_FROM_MODULE_MEETING', '');
		$smarty->assign('GCAL_FROM_MODULE_TASK', '');
		$smarty->assign('GCAL_FROM_MODULE_CALL', '');
		$smarty->assign('GCAL_REDIRECT_URI', '');

		if (array_key_exists('gcal_from_module', $admin->settings)) {

			$enabledModules = $admin->settings['gcal_from_module'];
			$modules = explode(",", $enabledModules);

			foreach ($modules as $key => $value) {
				switch ($value) {
				case 'meetings':
					$smarty->assign('GCAL_FROM_MODULE_MEETING', 'selected');
					break;
				case 'tasks':
					$smarty->assign('GCAL_FROM_MODULE_TASK', 'selected');
					break;
				case 'calls':
					$smarty->assign('GCAL_FROM_MODULE_CALL', 'selected');
					break;
				default:
					# code...
					break;
				}
			}
		}
		if (array_key_exists('gcal_client_id', $admin->settings)) {
			$smarty->assign('GCAL_CLIENT_ID', $admin->settings['gcal_client_id']);
		}
		if (array_key_exists('gcal_client_secret', $admin->settings)) {
			$smarty->assign('GCAL_CLIENT_SECRET', $admin->settings['gcal_client_secret']);
		}
		if (array_key_exists('gcal_redirect_uri', $admin->settings)) {
			$smarty->assign('GCAL_REDIRECT_URI', $admin->settings['gcal_redirect_uri']);
		} else {
			global $sugar_config, $suitecrm_version;
			$GLOBALS['log']->fatal('check sugar version'.$suitecrm_version);
			if(preg_match( "/^8.*/", $suitecrm_version) ) {
				$smarty->assign('GCAL_REDIRECT_URI', $sugar_config['site_url'] . "/legacy/index.php?entryPoint=generateCalenderEvent");
			} else {
				$smarty->assign('GCAL_REDIRECT_URI', $sugar_config['site_url'] . "/index.php?entryPoint=generateCalenderEvent");
			}
			
		}
		if (array_key_exists('gcal_name', $admin->settings)) {
			$smarty->assign('GCAL_NAME', $admin->settings['gcal_name']);
		}
		if (array_key_exists('gcal_enable', $admin->settings)) {
			$smarty->assign('GCAL_ENABLE', 'checked');
		}
		if (array_key_exists('gcal_event_module', $admin->settings)) {
			$smarty->assign('GCAL_TO_MODULE', $admin->settings['gcal_event_module']);
		}

		$smarty->display('modules/GCal/tpl/configureGCal.tpl');
	}
}
