<?php
/**
 *
 * SugarCRM Community Edition is a customer relationship management program developed by
 * SugarCRM, Inc. Copyright (C) 2004-2013 SugarCRM Inc.
 *
 * SuiteCRM is an extension to SugarCRM Community Edition developed by SalesAgility Ltd.
 * Copyright (C) 2011 - 2018 SalesAgility Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 *
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo and "Supercharged by SuiteCRM" logo. If the display of the logos is not
 * reasonably feasible for technical reasons, the Appropriate Legal Notices must
 * display the words "Powered by SugarCRM" and "Supercharged by SuiteCRM".
 */

$dictionary['ht_client_products'] = array(
    'table' => 'ht_client_products',
    'audited' => true,
    'inline_edit' => true,
    'duplicate_merge' => true,
    'fields' => array (
        
        'product_type' => array(
            'name' => 'product_type',
            'type' => 'enum',
            'options' => 'product_type_dom',
            'label' => 'LBL_PRODUCT_TYPE',
            'default' => '',
            'required' => false,
            'len' => 100,
            'audited' => true,
            'massupdate' => false,
            'duplicate_merge' => 'enabled',
            'reportable' => true,
            'importable' => 'true',
            'studio' => 'visible',
            'dependency' => false,
            'inline_edit' => false,
        ),
        'product_provider' => array(
            'name' => 'product_provider',
            'vname' => 'LBL_PRODUCT_PROVIDER',
            'type' => 'varchar',
            'len' => '255',
            'comment' => 'The provider of the product',
            'inline_edit' => false,
        ),
        'product_name' => array(
            'name' => 'product_name',
            'vname' => 'LBL_PRODUCT_NAME',
            'type' => 'varchar',
            'len' => '255',
            'comment' => 'The name of the product',
            'inline_edit' => false,
        ),
        'coverage_amount' => array(
            'name' => 'coverage_amount',
            'vname' => 'LBL_COVERAGE_AMOUNT',
            'type' => 'currency',
            'comment' => 'The coverage amount',
            'inline_edit' => false,
        ),
        'coverage_duration' => array(
            'name' => 'coverage_duration',
            'vname' => 'LBL_COVERAGE_DURATION',
            'type' => 'int',
            'comment' => 'The coverage duration in years',
        ),
        'premium_amount' => array(
            'name' => 'premium_amount',
            'vname' => 'LBL_PREMIUM_AMOUNT',
            'type' => 'currency',
            'comment' => 'The premium amount',
            'inline_edit' => false,
        ),
        'premium_frequency' => array(
            'name' => 'premium_frequency',
            'vname' => 'LBL_PREMIUM_FREQUENCY',
            'type' => 'varchar',
            'len' => '255',
            'comment' => 'The premium payment frequency',
            'inline_edit' => false,
        ),
        'funding_amount_fia' => array(
            'name' => 'funding_amount_fia',
            'vname' => 'LBL_FUNDING_AMOUNT_FIA',
            'type' => 'currency',
            'comment' => 'The funding amount for FIA',
            'inline_edit' => false,
        ),
        'product_duration_fia' => array(
            'name' => 'product_duration_fia',
            'vname' => 'LBL_PRODUCT_DURATION_FIA',
            'type' => 'int',
            'comment' => 'The product duration for FIA in years',
            'inline_edit' => false,
        ),
        'submit_date' => array(
            'name' => 'submit_date',
            'vname' => 'LBL_SUBMIT_DATE',
            'type' => 'date',
            'comment' => 'The date of submission',
        ),
        'approval_date' => array(
            'name' => 'approval_date',
            'vname' => 'LBL_APPROVAL_DATE',
            'type' => 'date',
            'comment' => 'The date of approval',
            'inline_edit' => false,
        ),
        'funded' => array(
            'name' => 'funded',
            'vname' => 'LBL_FUNDED',
            'type' => 'enum',
            'options' => 'checkbox_dom',
            'comment' => 'Funded',
            'inline_edit' => false,
        ),
        'in_force' => array(
            'name' => 'in_force',
            'vname' => 'LBL_IN_FORCE',
            'type' => 'enum',
            'options' => 'checkbox_dom',
            'comment' => 'In Force',
            'inline_edit' => false,
        ),
        'split_agent' => array(
            'name' => 'split_agent',
            'vname' => 'LBL_SPLIT_AGENT',
            'type' => 'enum',
            'options' => 'checkbox_dom',
            'comment' => 'The Split Agent',
            'inline_edit' => false,
        ),
        'split_agent_name' => array(
            'name' => 'split_agent_name',
            'vname' => 'LBL_SPLIT_AGENT_NAME',
            'type' => 'varchar',
            'len' => '255',
            'comment' => 'Split Agent Name',
            'inline_edit' => false,
        ),
        'split_agent_social' => array(
            'name' => 'split_agent_social',
            'vname' => 'LBL_SPLIT_AGENT_SOCIAL',
            'type' => 'varchar',
            'len' => '255',
            'comment' => 'Split Agent Social',
            'inline_edit' => false,
        ),
        
        //related field start
        'contact_name' => 
        array (
				'name' => 'contact_name',
				'rname' => 'name',
				'id_name' => 'contact_id',
				'vname' => 'LBL_CONTACT_NAME',
				'type' => 'relate',
				'relationship' =>'contact_ht_client_products',
				'link' => 'contact_ht_client_products',
				'table' => 'contacts',
				'join_name' => 'contacts',
				'isnull' => 'true',
				'module' => 'Contacts',
				'bean_name'=>'Contacts',
				'source' => 'non-db',
				'unified_search' => true,
                'inline_edit' => false,
        ),
        'contact_id' => 
    	array (
				'name' => 'contact_id',
				'type' => 'id',
				'module' => 'ht_client_products',
				'vname' => 'LBL_CONTACT_ID',
				'audited' => true,
				'massupdate' => false,
				'inline_edit' => false,
    	),
        
        //related field start
        
        
),
    'relationships' => array (
),
    'optimistic_locking' => true,
    'unified_search' => true,
);
if (!class_exists('VardefManager')) {
        require_once('include/SugarObjects/VardefManager.php');
}
VardefManager::createVardef('ht_client_products', 'ht_client_products', array('basic','assignable','security_groups'));