<?php
if (!defined('sugarEntry')) {
	define('sugarEntry', true);
}
global $current_user;
require_once 'google-calendar-api.php';
if (empty($current_user->id)) {
	$current_user->retrieve($_SESSION['authenticated_user_id']);
} // Google passes a parameter 'code' in the Redirect Url
if (isset($_GET['code'])) {
	try {
		$capi = new GoogleCalendarApi();
		require_once 'modules/Administration/Administration.php';

		$admin = new Administration();
		$admin->retrieveSettings();
		$calendar_enable = $admin->settings['gcal_enable'];
		$CLIENT_ID = $admin->settings['gcal_client_id'];
		$CLIENT_SECRET = $admin->settings['gcal_client_secret'];
		$CLIENT_REDIRECT_URL = $admin->settings['gcal_redirect_uri'];

		// Get the access token
		$data = $capi->GetAccessToken($CLIENT_ID, $CLIENT_REDIRECT_URL, $CLIENT_SECRET, $_GET['code']);
		//$GLOBALS['log']->fatal(print_r($data, 1));
		// Save the access token as a session variable
		$_SESSION['access_token'] = $data['access_token'];
		$_SESSION['bv_access_token'] = $data['access_token'];

		if ($calendar_enable) {
			global $sugar_config;
			require_once 'modules/Users/User.php';
			$calendar_name = $admin->settings['gcal_name'];
			if (empty($calendar_name)) {
				$calendar_name = $admin->settings['system_name'];
			}
			$oUser = new User();
			$oUser->retrieve($_SESSION['authenticated_user_id']);
			$oUser->gcal_auth = $data['access_token'];
			if (!empty($data['refresh_token'])) {
				$oUser->gcal_auth_refresh = $data['refresh_token'];
			}
			$oUser->gcal_auth_expire = $data['expires_in'];
			$oUser->processed = true;
			$oUser->save();
			//get calendar list
			$calendarList = $capi->GetCalendarsList($oUser->gcal_auth);
			$createCalFlag = true;
			$calenderId = '';
			foreach ($calendarList as $key => $value) {
				if ($value['summary'] == $calendar_name) {
					$createCalFlag = false;
					$calenderId = $value['id'];
					break;
				}
			}
			$user_timezone = $capi->GetUserCalendarTimezone($oUser->gcal_auth);

			if ($createCalFlag) {
				$calenderId = $capi->CreateCalendar($oUser->gcal_auth, $calendar_name, $user_timezone);

				$oUser->gcal_calendar_id = $calenderId['id'];
			} else {
				if (!empty($oUser->gcal_calendar_id)) {
					$calenderId = $capi->UpdateCalendar($oUser->gcal_auth, $calendar_name, $oUser->gcal_calendar_id, $user_timezone);
				} else {
					$oUser->gcal_calendar_id = $calenderId;
				}
			}
			$oUser->processed = true;
			$oUser->save();
		}

		// Redirect to the page where user can create event
		//header('Location: ' . $sugar_config['site_url'] . '/public/#users/edit/' . $_SESSION['authenticated_user_id']);
		SugarApplication::redirect('index.php?module=Users&action=DetailView&record=' . $_SESSION['authenticated_user_id']);
		exit();
	} catch (Exception $e) {
		echo $e->getMessage();
		exit();
	}
}

?>